"use strict";
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
        return !!right[Symbol.hasInstance](left);
    } else {
        return left instanceof right;
    }
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function _object_without_properties(source, excluded) {
    if (source == null) return {};
    var target = _object_without_properties_loose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _object_without_properties_loose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _to_primitive(input, hint) {
    if (_type_of(input) !== "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== undefined) {
        var res = prim.call(input, hint || "default");
        if (_type_of(res) !== "object") return res;
        throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
}
function _to_property_key(arg) {
    var key = _to_primitive(arg, "string");
    return _type_of(key) === "symbol" ? key : String(key);
}
function _type_of(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return(g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g);
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
var _Math;
Object.defineProperty(exports, "__esModule", {
    value: true
});
var numberPrecision = require("number-precision");
var loadjs = require("@cgxqd/loadjs");
var PromisePolyfill = require("promise-polyfill");
function _interopDefault(e) {
    return e && e.__esModule ? e : {
        default: e
    };
}
var loadjs__default = /*#__PURE__*/ _interopDefault(loadjs);
var PromisePolyfill__default = /*#__PURE__*/ _interopDefault(PromisePolyfill);
// test2awegaweg
var __defProp = Object.defineProperty;
var __defNormalProp = function(obj, key, value) {
    return key in obj ? __defProp(obj, key, {
        enumerable: true,
        configurable: true,
        writable: true,
        value: value
    }) : obj[key] = value;
};
var __export = function(target, all) {
    for(var name in all)__defProp(target, name, {
        get: all[name],
        enumerable: true
    });
};
var __publicField = function(obj, key, value) {
    __defNormalProp(obj, (typeof key === "undefined" ? "undefined" : _type_of(key)) !== "symbol" ? key + "" : key, value);
    return value;
};
// src/_/matche.ts
var matche_exports = {};
__export(matche_exports, {
    getType: function() {
        return getType;
    },
    getTypeTag: function() {
        return getTypeTag;
    },
    hasIterable: function() {
        return hasIterable;
    },
    hasOwn: function() {
        return hasOwn;
    },
    isArray: function() {
        return isArray;
    },
    isArrayLike: function() {
        return isArrayLike;
    },
    isArraySafeLength: function() {
        return isArraySafeLength;
    },
    isBigInt: function() {
        return isBigInt;
    },
    isBoolean: function() {
        return isBoolean;
    },
    isDate: function() {
        return isDate;
    },
    isEmpty: function() {
        return isEmpty;
    },
    isFunction: function() {
        return isFunction;
    },
    isInteger: function() {
        return isInteger;
    },
    isNaN: function() {
        return isNaN2;
    },
    isNull: function() {
        return isNull;
    },
    isNumber: function() {
        return isNumber;
    },
    isObject: function() {
        return isObject;
    },
    isPrimeObject: function() {
        return isPrimeObject;
    },
    isPromise: function() {
        return isPromise;
    },
    isRegExp: function() {
        return isRegExp;
    },
    isString: function() {
        return isString;
    },
    isSymbol: function() {
        return isSymbol;
    },
    isUndefined: function() {
        return isUndefined;
    }
});
// src/_/const.ts
var ARRAY_MAX_SAFE_INTEGER = 4294967296;
var MAX_INTEGER = 17976931348623157e292;
var INFINITY = 1 / 0;
var NAN = 0 / 0;
var reTrim = /^s+|s+$/g;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
// src/_/matche.ts
var getTypeTag = function(value) {
    return Object.prototype.toString.call(value);
};
var getType = function(value) {
    var _getTypeTag_match;
    return ((_getTypeTag_match = getTypeTag(value).match(/\s([a-z]+)/i)) === null || _getTypeTag_match === void 0 ? void 0 : _getTypeTag_match[1].toLocaleLowerCase()) || "";
};
var isNaN2 = function(value) {
    return isNumber(value) && value !== +value;
};
var isNull = function(value) {
    return getType(value) === "null";
};
var isUndefined = function(value) {
    return value === void 0;
};
var isBoolean = function(value) {
    return typeof value === "boolean";
};
var isBigInt = function(value) {
    return (typeof value === "undefined" ? "undefined" : _type_of(value)) === "bigint";
};
var isNumber = function(value) {
    return typeof value === "number";
};
var isString = function(value) {
    return typeof value === "string";
};
var isSymbol = function(value) {
    return (typeof value === "undefined" ? "undefined" : _type_of(value)) == "symbol" || isObject(value) && getTypeTag(value) == "[object Symbol]";
};
var isPrimeObject = function(value) {
    return getType(value) === "object";
};
var isObject = function(value) {
    var type = typeof value === "undefined" ? "undefined" : _type_of(value);
    return value != null && (type === "object" || type === "function");
};
var isRegExp = function(value) {
    return getType(value) === "regexp";
};
var isDate = function(value) {
    return getType(value) === "date";
};
var isArray = function(value) {
    return Array.isArray(value);
};
var isFunction = function(value) {
    return typeof value === "function";
};
var isPromise = function(value) {
    if (Promise && Promise.resolve) {
        return Promise.resolve(value) === value;
    }
    return false;
};
var isInteger = function(value) {
    return value % 1 === 0;
};
var isArraySafeLength = function(value) {
    return isNumber(value) && value >= 0 && value < ARRAY_MAX_SAFE_INTEGER;
};
var isArrayLike = function(value) {
    return value && isObject(value) && isFinite(value.length) && isArraySafeLength(value.length);
};
var isEmpty = function(value) {
    if (value == null) return true;
    if (isBoolean(value)) return !value;
    if (isNumber(value)) return !value;
    if (_instanceof(value, Error)) return value.message === "";
    switch(getType(value)){
        case "function":
        case "string":
        case "array":
            {
                return !value.length;
            }
    }
    if (typeof value === "object") {
        if (hasIterable && typeof value[Symbol.iterator] === "function") {
            var size = 0;
            value.forEach(function() {
                return size++;
            });
            return !size;
        }
        return !Object.keys(value).length;
    }
    return false;
};
var hasOwn = function(target, key) {
    return Object.prototype.hasOwnProperty.call(target, key);
};
var hasIterable = !!(typeof Symbol === "function" && Symbol.iterator);
// src/_/convert.ts
var convert_exports = {};
__export(convert_exports, {
    toArray: function() {
        return toArray;
    },
    toArraySafeLength: function() {
        return toArraySafeLength;
    },
    toFinite: function() {
        return toFinite;
    },
    toInteger: function() {
        return toInteger;
    },
    toNumber: function() {
        return toNumber;
    },
    toString: function() {
        return toString;
    }
});
var toInteger = function(value) {
    var number = toFinite(value);
    var remainder = number % 1;
    return remainder ? number - remainder : number;
};
var toArraySafeLength = function(value) {
    var len = toInteger(value);
    return Math.min(Math.max(len, 0), ARRAY_MAX_SAFE_INTEGER);
};
var toArray = function(value) {
    var def = [];
    var type = getType(value);
    if (type === "string") return Array.prototype.slice.call(value);
    if (isArrayLike(value)) {
        var length = toArraySafeLength(value.length);
        def = new Array(length);
        for(var index = 0; index < length; index++)def[index] = value[index];
    }
    if (type === "map") value.forEach(function(value2, key) {
        return def.push([
            key,
            value2
        ]);
    });
    if (type === "set") value.forEach(function(value2) {
        return def.push(value2);
    });
    return def;
};
var toString = function(value) {
    var type = getType(value);
    if (value == null) return "";
    if ([
        "string",
        "array"
    ].includes(type)) return String(value);
    if (type === "symbol") value = value.toString();
    var result = "".concat(value);
    return result == "0" && 1 / value == -INFINITY ? "-0" : result;
};
var toNumber = function(value) {
    var type = getType(value);
    if (type === "number") return value;
    if (type === "symbol") return NAN;
    if (isObject(value)) {
        var other = typeof value.valueOf === "function" ? value.valueOf() : value;
        value = isObject(other) ? "".concat(other) : other;
    }
    if (type !== "string") return value === 0 ? value : +value;
    value = value.replace(reTrim, "");
    var isBinary = reIsBinary.test(value);
    return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : // 不是的话就判断是否为有错的16进制，是的话返回NaN，否就转化为数字返回
    reIsBadHex.test(value) ? NAN : +value;
};
var toFinite = function(value) {
    value = toNumber(value);
    if (value === INFINITY || value === -INFINITY) {
        var sign = value < 0 ? -1 : 1;
        return sign * MAX_INTEGER;
    }
    return value === value ? value : 0;
};
// src/modules/number.ts
var number_exports = {};
__export(number_exports, {
    divide: function() {
        return numberPrecision.divide;
    },
    minus: function() {
        return numberPrecision.minus;
    },
    plus: function() {
        return numberPrecision.plus;
    },
    randomInteger: function() {
        return randomInteger;
    },
    round: function() {
        return round;
    },
    times: function() {
        return numberPrecision.times;
    }
});
var randomInteger = function(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
};
var round = function(value) {
    var decimal = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return Number("".concat(Math.round(Number("".concat(value, "e").concat(decimal))), "e-").concat(decimal));
};
// src/modules/string.ts
var string_exports = {};
__export(string_exports, {
    guid: function() {
        return guid;
    },
    mask: function() {
        return mask;
    },
    maskLeft: function() {
        return maskLeft;
    },
    maskRight: function() {
        return maskRight;
    },
    sensitive: function() {
        return sensitive;
    },
    sensitiveLeft: function() {
        return sensitiveLeft;
    },
    sensitiveRight: function() {
        return sensitiveRight;
    },
    toThousands: function() {
        return toThousands;
    },
    trim: function() {
        return trim;
    },
    uuid: function() {
        return uuid;
    }
});
var sensitive = function(value, startIndex, endIndex) {
    var symbol = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : "*";
    var reg = new RegExp("^(.{".concat(startIndex, "})(.{").concat(endIndex - startIndex, "})(.").concat(endIndex >= value.length ? "?" : "+", ")$"));
    return value.replace(reg, function($0, $1, $2, $3) {
        return $1 + $2.replace(/./g, symbol) + $3;
    });
};
var mask = sensitive;
var sensitiveLeft = function() {
    var value = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "", index = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, symbol = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "*";
    return sensitive(value, 0, index, symbol);
};
var maskLeft = sensitiveLeft;
var sensitiveRight = function() {
    var value = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "", index = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, symbol = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "*";
    var strL = value.length;
    return sensitive(value, index > strL ? 0 : strL - index, strL, symbol);
};
var maskRight = sensitiveRight;
var uuid = function(len, radix) {
    var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split("");
    var uuid2 = [];
    var i = 0;
    radix = radix || chars.length;
    if (len) {
        for(i = 0; i < len; i++)uuid2[i] = chars[0 | Math.random() * radix];
    } else {
        var r;
        uuid2[8] = uuid2[13] = uuid2[18] = uuid2[23] = "-";
        uuid2[14] = "4";
        for(i = 0; i < 36; i++){
            if (!uuid2[i]) {
                r = 0 | Math.random() * 16;
                uuid2[i] = chars[i == 19 ? r & 3 | 8 : r];
            }
        }
    }
    return uuid2.join("");
};
var guid = function() {
    return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function(c) {
        var r = Math.random() * 16 | 0, v = c == "x" ? r : r & 3 | 8;
        return v.toString(16);
    });
};
var toThousands = function(value) {
    var symbol = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "";
    return toString(value).replace(/(?=\B)(?=(\d{3})+\.)/g, ",").replace(/^/, symbol);
};
var trim = function(value) {
    return toString(value).replace(/^\s+|\s+$/g, "");
};
// src/modules/array.ts
var array_exports = {};
__export(array_exports, {
    convert: function() {
        return convert;
    },
    convertFlat: function() {
        return convertFlat;
    },
    convertFlatPaths: function() {
        return convertFlatPaths;
    },
    convertTree: function() {
        return convertTree;
    },
    findPathByLeaf: function() {
        return findPathByLeaf;
    },
    maxNumBy: function() {
        return maxNumBy;
    },
    minNumBy: function() {
        return minNumBy;
    },
    orderBy: function() {
        return orderBy;
    },
    shuffle: function() {
        return shuffle;
    },
    treeFlat: function() {
        return treeFlat;
    },
    unique: function() {
        return unique;
    },
    uniqueBy: function() {
        return uniqueBy;
    },
    whileEach: function() {
        return whileEach;
    }
});
// src/modules/object.ts
var object_exports = {};
__export(object_exports, {
    deepClone: function() {
        return deepClone;
    },
    get: function() {
        return get;
    },
    merge: function() {
        return merge;
    },
    selector: function() {
        return selector;
    }
});
// src/_/clone.ts
var cloneRegExp = function(targe) {
    var reFlags = /\w*$/;
    var result = new targe.constructor(targe.source, reFlags.exec(targe));
    result.lastIndex = targe.lastIndex;
    return result;
};
var cloneSymbol = function(value) {
    return Object(Symbol.prototype.valueOf.call(value));
};
var cloneSet = function(target, map, clone) {
    var ctor = /* @__PURE__ */ new Set();
    target.forEach(function(value) {
        return ctor.add(clone(value, map));
    });
    return ctor;
};
var cloneMap = function(target, map, clone) {
    var ctor = /* @__PURE__ */ new Map();
    target.forEach(function(value, key) {
        return ctor.set(key, clone(value, map));
    });
    return ctor;
};
// src/modules/object.ts
var deepClone = function(target) {
    var map = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : /* @__PURE__ */ new Map();
    if (target === null) return null;
    if (typeof target !== "object") return target;
    var _target, proto;
    switch(getType(target)){
        case "array":
            _target = [];
            break;
        case "regexp":
            return cloneRegExp(target);
        case "symbol":
            return cloneSymbol(target);
        case "date":
            _target = new Date(target.getTime());
            break;
        case "set":
            return cloneSet(target, map, deepClone);
        case "map":
            return cloneMap(target, map, deepClone);
        default:
            proto = Object.getPrototypeOf(target);
            _target = Object.create(proto);
            break;
    }
    if (map.get(target)) return map.get(target);
    map.set(target, _target);
    for(var i in target){
        _target[i] = deepClone(target[i], map);
    }
    return _target;
};
var merge = function(target, source) {
    for(var key in source){
        if (!hasOwn(target, key)) {
            target[key] = source[key];
        } else if (isPrimeObject(source[key]) && isPrimeObject(target[key])) {
            merge(target[key], source[key]);
        }
    }
    return target;
};
var get = function(target, path, defaultValue) {
    var keys = toString(path).match(/([^.[\]]+)/g) || [];
    while(keys.length && target){
        var key = keys.shift() || "";
        target = target[key];
    }
    return target == null ? defaultValue : target;
};
var selector = get;
// src/_/checkType.ts
function checkFunc(value) {
    if (typeof value !== "function") throw new TypeError("".concat(getTypeTag(value), " is not a function"));
}
// src/_/es.array.ts
function find(array, cb) {
    checkFunc(cb);
    for(var index = 0; index < array.length; index++){
        var value = array[index];
        var result = cb(value, index, array);
        if (result) return value;
    }
}
function findIndex(array, cb) {
    checkFunc(cb);
    for(var index = 0; index < array.length; index++){
        var value = array[index];
        var result = cb(value, index, array);
        if (result) return index;
    }
    return -1;
}
// src/modules/array.ts
var uniqueBy = function uniqueBy(array, key) {
    return array.filter(function(element, index) {
        return findIndex(array, function(item) {
            return !key ? item === element : get(item, key) === get(element, key);
        }) === index;
    });
};
var unique = function(arr) {
    return uniqueBy(arr);
};
var maxNumBy = function(array, key) {
    return find(array, function(item) {
        var _Math;
        return get(item, key) === (_Math = Math).max.apply(_Math, _to_consumable_array(array.map(function(row) {
            return get(row, key);
        })));
    });
};
var minNumBy = function(array, key) {
    return find(array, function(item) {
        return get(item, key) === (_Math = Math).min.apply(_Math, _to_consumable_array(array.map(function(row) {
            return get(row, key);
        })));
    });
};
var shuffle = function(array) {
    var i = array.length;
    while(i){
        var j = Math.floor(Math.random() * i--);
        var ref;
        ref = [
            array[i],
            array[j]
        ], array[j] = ref[0], array[i] = ref[1], ref;
    }
    return array;
};
var convertTree = function() {
    var list = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [], option = arguments.length > 1 ? arguments[1] : void 0;
    var defOpt = {
        children: "children",
        pid: "pid",
        id: "id",
        rootId: 0
    };
    var _Object_assign = Object.assign(defOpt, option), pid = _Object_assign.pid, id = _Object_assign.id, children = _Object_assign.children, rootId = _Object_assign.rootId;
    return list.filter(function(item) {
        var child = list.filter(function(c) {
            return c[pid] === item[id];
        });
        item[children] = child;
        return item[pid] === rootId;
    });
};
var convert = convertTree;
var treeFlat = function(nodes) {
    var childrenName = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "children";
    var rest = nodes.reduce(function(acc, curr) {
        var tmp = curr[childrenName], children = tmp === void 0 ? [] : tmp, keys = _object_without_properties(curr, [
            childrenName
        ].map(_to_property_key));
        return acc.concat([
            keys
        ], treeFlat(children, childrenName));
    }, []);
    return rest;
};
var convertFlat = treeFlat;
var convertFlatPaths = function(nodes) {
    var childrenName = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "children", path = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [], paths = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : [];
    for(var i = 0; i < nodes.length; i++){
        var item = nodes[i];
        var children = item[childrenName], rest = _object_without_properties(item, [
            childrenName
        ].map(_to_property_key));
        var _paths = _to_consumable_array(path).concat([
            rest
        ]);
        if (children) {
            convertFlatPaths(children, childrenName, _paths, paths);
        } else paths.push(_paths);
    }
    return paths;
};
var findPathByLeaf = function(leafKey, leafValue, nodes) {
    var childrenName = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : "children", path = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : [];
    for(var i = 0; i < nodes.length; i++){
        var _nodes_i = nodes[i], _child = _nodes_i[childrenName], rest = _object_without_properties(_nodes_i, [
            childrenName
        ].map(_to_property_key));
        var tmpPath = _to_consumable_array(path);
        if (leafValue == nodes[i][leafKey]) return tmpPath;
        tmpPath.push(rest);
        if (nodes[i][childrenName]) {
            var findResult = findPathByLeaf(leafKey, leafValue, nodes[i][childrenName], childrenName, tmpPath);
            if (findResult) {
                return findResult;
            }
        }
    }
};
var orderBy = function(array, sortKey, sortBy) {
    return _to_consumable_array(array).sort(function(a, b) {
        return sortKey.reduce(function(acc, key, i) {
            if (acc === 0) {
                var _ref = _sliced_to_array(sortBy && sortBy[i] === "desc" ? [
                    b[key],
                    a[key]
                ] : [
                    a[key],
                    b[key]
                ], 2), p1 = _ref[0], p2 = _ref[1];
                acc = p1 > p2 ? 1 : p1 < p2 ? -1 : 0;
            }
            return acc;
        }, 0);
    });
};
function whileEach(array, cb) {
    var max = array.length - 1;
    var index = -1;
    while(index++ < max){
        cb && cb(array[index], index, array);
    }
}
// src/modules/functional.ts
var functional_exports = {};
__export(functional_exports, {
    debounce: function() {
        return debounce;
    },
    debounceEnd: function() {
        return debounceEnd;
    },
    debounceStart: function() {
        return debounceStart;
    },
    memoize: function() {
        return memoize;
    },
    queryVar: function() {
        return queryVar;
    },
    sleep: function() {
        return sleep;
    },
    throttle: function() {
        return throttle;
    }
});
function memoize(func, resolver) {
    var _this = this;
    var memoizify = function() {
        for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
            args[_key] = arguments[_key];
        }
        var key = resolver ? resolver.apply(_this, args) : args[0];
        var cache = memoizify.cache;
        if (cache.has(key)) return cache.get(key);
        var result = func.apply(_this, args);
        memoizify.cache = cache.set(key, result) || cache;
        return result;
    };
    memoizify.cache = /* @__PURE__ */ new Map();
    return memoizify;
}
var queryVar = function() {
    var _ref = _async_to_generator(function(condition) {
        var delay;
        var _arguments = arguments;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    delay = _arguments.length > 1 && _arguments[1] !== void 0 ? _arguments[1] : 1e3;
                    _state.label = 1;
                case 1:
                    if (!!condition()) return [
                        3,
                        3
                    ];
                    return [
                        4,
                        sleep(delay)
                    ];
                case 2:
                    _state.sent();
                    return [
                        3,
                        1
                    ];
                case 3:
                    return [
                        2,
                        condition()
                    ];
            }
        });
    });
    return function queryVar(condition) {
        return _ref.apply(this, arguments);
    };
}();
var sleep = function(delay) {
    return new Promise(function(resolve) {
        var timer = setTimeout(function() {
            clearTimeout(timer);
            resolve(timer);
        }, delay);
    });
};
var debounce = function(fn, delay) {
    var immediate = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    var timer;
    var status = true;
    if (!immediate) return function debounce() {
        for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
            args[_key] = arguments[_key];
        }
        var _this = this;
        if (timer) clearTimeout(timer);
        timer = setTimeout(function() {
            return fn.apply(_this, args);
        }, delay);
    };
    else return function() {
        for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
            args[_key] = arguments[_key];
        }
        clearTimeout(timer);
        if (status) {
            status = false;
            fn.apply(this, args);
        }
        timer = setTimeout(function() {
            return status = true;
        }, delay);
    };
};
var debounceStart = function(fn) {
    var delay = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return debounce(fn, delay, true);
};
var debounceEnd = function(fn) {
    var delay = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return debounce(fn, delay, false);
};
var throttle = function(fn, delay) {
    var timer;
    return function throttle() {
        for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
            args[_key] = arguments[_key];
        }
        var _this = this;
        if (!timer) {
            timer = setTimeout(function() {
                clearTimeout(timer);
                timer = void 0;
                fn.apply(_this, args);
            }, delay);
        }
    };
};
// src/modules/browser.ts
var browser_exports = {};
__export(browser_exports, {
    blobToDataURL: function() {
        return blobToDataURL;
    },
    dataURLtoBlob: function() {
        return dataURLtoBlob;
    },
    downloadContent: function() {
        return downloadContent;
    },
    dynamicImport: function() {
        return dynamicImport;
    },
    getImgToBase64: function() {
        return getImgToBase64;
    },
    getImgToBlob: function() {
        return getImgToBlob;
    },
    setClipboardData: function() {
        return setClipboardData;
    }
});
var blobToDataURL = function(stream) {
    return new Promise(function(succ, fail) {
        var reader = new FileReader();
        reader.readAsDataURL(stream);
        reader.onload = function() {
            succ(reader.result);
        };
        reader.onerror = function(err) {
            fail(err);
        };
    });
};
var dataURLtoBlob = function(dataURL) {
    var _arr__match;
    var arr = dataURL.split(",") || "";
    var mime = (_arr__match = arr[0].match(/:(.*?);/)) === null || _arr__match === void 0 ? void 0 : _arr__match[1];
    var bstr = atob(arr[1]);
    var n = bstr.length;
    var u8arr = new Uint8Array(n);
    while(n--){
        u8arr[n] = bstr.charCodeAt(n);
    }
    return new Blob([
        u8arr
    ], {
        type: mime
    });
};
var getImgToBase64 = function(url2) {
    return new Promise(function(succ, fail) {
        var canvas = document.createElement("canvas");
        var ctx = canvas.getContext("2d");
        var img = new Image();
        img.crossOrigin = "Anonymous";
        img.onload = function() {
            canvas.height = img.height;
            canvas.width = img.width;
            ctx === null || ctx === void 0 ? void 0 : ctx.drawImage(img, 0, 0);
            var dataURL = canvas.toDataURL("image/jpg");
            succ(dataURL);
        };
        img.onerror = function(err) {
            return fail(err);
        };
        img.src = url2;
    });
};
var getImgToBlob = function() {
    var _ref = _async_to_generator(function(url2) {
        var dataURL;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        getImgToBase64(url2)
                    ];
                case 1:
                    dataURL = _state.sent();
                    return [
                        2,
                        dataURLtoBlob(dataURL)
                    ];
            }
        });
    });
    return function getImgToBlob(url2) {
        return _ref.apply(this, arguments);
    };
}();
var downloadContent = function(fileName, content) {
    var type = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "text/plain";
    var el = document.createElement("a");
    var blob = new Blob([
        content
    ], {
        type: type
    });
    el.href = URL.createObjectURL(blob);
    el.download = fileName;
    el.addEventListener("click", function(e) {
        return e.stopImmediatePropagation();
    });
    document.body.appendChild(el);
    el.click();
    document.body.removeChild(el);
};
var setClipboardData = function(value) {
    var aux = document.createElement("input");
    aux.setAttribute("value", value);
    document.body.appendChild(aux);
    aux.select();
    document.execCommand("copy");
    document.body.removeChild(aux);
};
var dynamicImport = function(path, bundleId, cb) {
    return new Promise(function(resolve, reject) {
        var Loaded = cb ? cb : function() {
            return window[bundleId];
        };
        if (Loaded()) return resolve(Loaded());
        if (!loadjs__default.default.isDefined(bundleId)) loadjs__default.default(path, bundleId);
        loadjs__default.default.ready(bundleId, {
            success: function() {
                return resolve(queryVar(Loaded, 100));
            },
            error: function(depsNotFound) {
                return reject(depsNotFound);
            }
        });
    });
};
// src/modules/url.ts
var url_exports = {};
__export(url_exports, {
    url: function() {
        return url;
    },
    urlSearchParams: function() {
        return urlSearchParams;
    },
    urlSearchStringify: function() {
        return urlSearchStringify;
    }
});
// src/_/uri-component.ts
function encode(str) {
    var replace = {
        "!": "%21",
        "'": "%27",
        "(": "%28",
        ")": "%29",
        "~": "%7E",
        "%20": "+",
        "%00": "\x00"
    };
    return encodeURIComponent(str).replace(/[!'\\(\\)~]|%20|%00/g, function(match) {
        return replace[match];
    });
}
function decode(str) {
    return toString(str).replace(/[ +]/g, "%20").replace(/(%[a-f0-9]{2})+/gi, function(match) {
        return decodeURIComponent(match);
    });
}
// src/modules/url.ts
function urlSearchParams(url2) {
    var _exec;
    var result = {};
    var _exec_;
    var search = (_exec_ = (_exec = /(?=\??)[^\\?]*$/g.exec(url2)) === null || _exec === void 0 ? void 0 : _exec[0]) !== null && _exec_ !== void 0 ? _exec_ : "";
    search.split("&").forEach(function(item) {
        var _item_split = _sliced_to_array(item.split("="), 2), key = _item_split[0], tmp = _item_split[1], value = tmp === void 0 ? "" : tmp;
        if (key) result[key] = encode(value);
    });
    return result;
}
var urlSearchStringify = function(params) {
    return isObject(params) ? Object.keys(params).map(function(key) {
        return "".concat(key, "=").concat(decode(params[key]));
    }).join("&") : "";
};
var url = function(url2) {
    var isURLRegExp = /^((https?:)\/\/(([^:/?#]*)(?::([0-9]+))?))([/]{0,1}[^?#]*)(\?[^#]*|)(#.*|)$/;
    var usvURL = encodeURI(trim(url2));
    try {
        var _isURLRegExp_exec = _sliced_to_array(isURLRegExp.exec(usvURL), 9), href = _isURLRegExp_exec[0], origin = _isURLRegExp_exec[1], protocol = _isURLRegExp_exec[2], host = _isURLRegExp_exec[3], hostName = _isURLRegExp_exec[4], tmp = _isURLRegExp_exec[5], port = tmp === void 0 ? "" : tmp, tmp1 = _isURLRegExp_exec[6], pathname = tmp1 === void 0 ? "/" : tmp1, search = _isURLRegExp_exec[7], hash = _isURLRegExp_exec[8];
        return {
            href: href,
            origin: origin,
            protocol: protocol,
            host: host,
            hostName: hostName,
            port: port,
            pathname: pathname,
            search: search,
            hash: hash
        };
    } catch (err) {
        throw new Error("Raises a SYNTAX ERROR exception as 'about:blank/".concat(url2, "' is not valid"));
    }
};
// src/modules/date.ts
var date_exports = {};
__export(date_exports, {
    countDown: function() {
        return countDown;
    },
    formatHMS: function() {
        return formatHMS;
    },
    formatTime: function() {
        return formatTime;
    },
    unix: function() {
        return unix;
    }
});
var formatTime = function(value, format) {
    var nowDate = new Date(value);
    var weeks = [
        "日",
        "一",
        "二",
        "三",
        "四",
        "五",
        "六"
    ];
    var time = new Date(+nowDate + 8 * 3600 * 1e3).toISOString().substr(0, 19).replace(/[a-z]/i, " ");
    var _exec = _sliced_to_array(/(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})/g.exec(time), 7), _ = _exec[0], YYYY = _exec[1], MM = _exec[2], DD = _exec[3], hh = _exec[4], mm = _exec[5], ss = _exec[6];
    var filterTime = function(type, _2) {
        return type.slice(0, _2.length);
    };
    return format.replace(/(Y{1,4})/g, function($1) {
        return filterTime(YYYY, $1);
    }).replace(/(M{1,2})/g, function($1) {
        return filterTime(MM, $1);
    }).replace(/(D{1,2})/g, function($1) {
        return filterTime(DD, $1);
    }).replace(/(h{1,2})/g, function($1) {
        return filterTime(hh, $1);
    }).replace(/(m{1,2})/g, function($1) {
        return filterTime(mm, $1);
    }).replace(/(s{1,2})/g, function($1) {
        return filterTime(ss, $1);
    }).replace(/(W{1})/g, function($1) {
        return weeks[nowDate.getDay()];
    }).replace(/(Q{1})/g, function($1) {
        return toString(Math.floor((nowDate.getMonth() + 3) / 3));
    });
};
var formatHMS = function(value) {
    var str = "";
    if (value > 3600 * 24) {
        str = Math.floor(value / 3600 / 24) + "d" + Math.floor(value / 3600 % 24) + "h" + Math.floor(value % 3600 / 60) + "m" + value % 60 + "s";
    } else if (value > 3600) {
        str = Math.floor(value / 3600) + "h" + Math.floor(value % 3600 / 60) + "m" + value % 60 + "s";
    } else if (value > 60) {
        str = Math.floor(value / 60) + "m" + value % 60 + "s";
    } else {
        str = value % 60 + "s";
    }
    return str;
};
var unix = function(value) {
    if (value === void 0) return unix(Date.now());
    return Math.floor(new Date(value).getTime() / 1e3);
};
var countDown = function(value) {
    var time = unix(value) - unix();
    return formatHMS(time);
};
// src/_/base64.ts
var base64_exports = {};
__export(base64_exports, {
    decode: function() {
        return decode2;
    },
    encode: function() {
        return encode2;
    }
});
var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
var encode2 = function() {
    var input = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "";
    var output = "";
    var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
    var i = 0;
    input = _utf8_encode(input);
    while(i < input.length){
        chr1 = input.charCodeAt(i++);
        chr2 = input.charCodeAt(i++);
        chr3 = input.charCodeAt(i++);
        enc1 = chr1 >> 2;
        enc2 = (chr1 & 3) << 4 | chr2 >> 4;
        enc3 = (chr2 & 15) << 2 | chr3 >> 6;
        enc4 = chr3 & 63;
        if (isNaN(chr2)) {
            enc3 = enc4 = 64;
        } else if (isNaN(chr3)) {
            enc4 = 64;
        }
        output = output + _keyStr.charAt(enc1) + _keyStr.charAt(enc2) + _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
    }
    return output;
};
var decode2 = function() {
    var input = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "";
    var output = "";
    var chr1, chr2, chr3;
    var enc1, enc2, enc3, enc4;
    var i = 0;
    input = input.replace(/[^A-Za-z0-9+/=]/g, "");
    while(i < input.length){
        enc1 = _keyStr.indexOf(input.charAt(i++));
        enc2 = _keyStr.indexOf(input.charAt(i++));
        enc3 = _keyStr.indexOf(input.charAt(i++));
        enc4 = _keyStr.indexOf(input.charAt(i++));
        chr1 = enc1 << 2 | enc2 >> 4;
        chr2 = (enc2 & 15) << 4 | enc3 >> 2;
        chr3 = (enc3 & 3) << 6 | enc4;
        output = output + String.fromCharCode(chr1);
        if (enc3 !== 64) {
            output = output + String.fromCharCode(chr2);
        }
        if (enc4 !== 64) {
            output = output + String.fromCharCode(chr3);
        }
    }
    output = _utf8_decode(output);
    return output;
};
function _utf8_encode(string) {
    string = string.replace(/\r\n/g, "\n");
    var utftext = "";
    for(var n = 0; n < string.length; n++){
        var c = string.charCodeAt(n);
        if (c < 128) {
            utftext += String.fromCharCode(c);
        } else if (c > 127 && c < 2048) {
            utftext += String.fromCharCode(c >> 6 | 192);
            utftext += String.fromCharCode(c & 63 | 128);
        } else {
            utftext += String.fromCharCode(c >> 12 | 224);
            utftext += String.fromCharCode(c >> 6 & 63 | 128);
            utftext += String.fromCharCode(c & 63 | 128);
        }
    }
    return utftext;
}
function _utf8_decode(utftext) {
    var string = "";
    var i = 0;
    var c = 0;
    var c2 = 0;
    var c3 = 0;
    while(i < utftext.length){
        c = utftext.charCodeAt(i);
        if (c < 128) {
            string += String.fromCharCode(c);
            i++;
        } else if (c > 191 && c < 224) {
            c2 = utftext.charCodeAt(i + 1);
            string += String.fromCharCode((c & 31) << 6 | c2 & 63);
            i += 2;
        } else {
            c2 = utftext.charCodeAt(i + 1);
            c3 = utftext.charCodeAt(i + 2);
            string += String.fromCharCode((c & 15) << 12 | (c2 & 63) << 6 | c3 & 63);
            i += 3;
        }
    }
    return string;
}
// src/_/compartment.ts
var Compartment = /*#__PURE__*/ function() {
    function Compartment() {
        var scopes = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
        _class_call_check(this, Compartment);
        __publicField(this, "scopes");
        __publicField(this, "runningEvalContext");
        this.scopes = scopes;
    }
    _create_class(Compartment, [
        {
            key: "destroy",
            value: function destroy() {
                if (this.runningEvalContext) {
                    this.runningEvalContext.remove();
                }
                Object.freeze(this);
            }
        },
        {
            key: "evaluate",
            value: function evaluate(jsCode) {
                var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
                if (this.runningEvalContext) {
                    this.runningEvalContext.remove();
                }
                this.runningEvalContext = createContextEval();
                return this.runningEvalContext.run(jsCode, this.scopes, options);
            }
        }
    ]);
    return Compartment;
}();
var createSrcDoc = function(param) {
    var origin = param.origin, senderId = param.senderId, receiverId = param.receiverId, _param_type = param.type, type = _param_type === void 0 ? "script" : _param_type;
    if (type === "script") {
        return '<!doctype html>\n  <html lang="en">\n  <body></body>\n  </html>';
    }
    return '<!doctype html>\n  <html lang="en">\n  <body>\n  <script>\n  const origin = "'.concat(origin, '";\n  const senderId = "').concat(senderId, '";\n  const receiverId = "').concat(receiverId, '";\n  const handleMessage = async (event) => {\n    if (event.source !== window.parent) {\n      return;\n    }\n    if (event.origin !== origin) {\n      return;\n    }\n    const { id, src } = event.data || {};\n    if (id !== receiverId) {\n      return;\n    }\n    try {\n      const AsyncFunction = Object.getPrototypeOf(async function () {}).constructor;\n      ').concat(function() {
        if (type === "module") {
            return "await import(`data:text/javascript;charset=utf-8, ${encodeURIComponent(src)}`);window.parent.postMessage({ id: senderId, result: undefined }, origin);";
        } else if (type === "AsyncFunction") {
            return "await new AsyncFunction(src)();window.parent.postMessage({ id: senderId, result: undefined }, origin);";
        } else {
            return "const result = eval(src);window.parent.postMessage({ id: senderId, result }, origin);";
        }
    }(), ';\n    } catch (error) {\n      window.parent.postMessage({ id: senderId, error: {message:error.message} }, origin);\n    }\n    window.removeEventListener("message", handleMessage);\n  };\n  window.addEventListener("message", handleMessage);\n  window.parent.postMessage({ id: senderId, ready: true }, origin);\n  </script>\n  </body>\n  </html>');
};
var createContextEval = function() {
    var iframe = document.createElement("iframe");
    iframe.setAttribute("style", "display: none;");
    var senderId = guid();
    var receiverId = guid();
    return {
        remove: function() {
            document.body.removeChild(iframe);
        },
        /**
     * @param src
     * @param scopes
     * @param options
     */ run: function(src) {
            var scopes = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            return new Promise(function(resolve, reject) {
                var handleMessage = function(event) {
                    if (event.source !== iframe.contentWindow) {
                        return;
                    }
                    var _ref = event.data || {}, id = _ref.id, result = _ref.result, _$error = _ref.error, ready = _ref.ready;
                    if (id !== senderId) {
                        return;
                    }
                    if (ready) {
                        var _iframe_contentWindow;
                        (_iframe_contentWindow = iframe.contentWindow) === null || _iframe_contentWindow === void 0 ? void 0 : _iframe_contentWindow.postMessage({
                            id: receiverId,
                            src: src
                        }, "*");
                        return;
                    }
                    if (_$error) {
                        reject(new Error(_$error.message));
                    } else {
                        resolve(result);
                    }
                    window.removeEventListener("message", handleMessage);
                };
                window.addEventListener("message", handleMessage);
                var executionType = options.type ? options.type : "script";
                iframe.srcdoc = createSrcDoc({
                    origin: window.location.origin,
                    senderId: senderId,
                    receiverId: receiverId,
                    type: executionType
                });
                document.body.appendChild(iframe);
                var iframeWindow = iframe.contentWindow;
                Object.keys(scopes).forEach(function(key) {
                    iframeWindow[key] = scopes[key];
                });
                if (executionType === "script") {
                    try {
                        resolve(iframeWindow.eval(src));
                    } catch (error) {
                        reject(error);
                    }
                }
            });
        }
    };
};
// package.json
var version = "0.1.1";
// src/_/createIterator.ts
function createIterator(array) {
    var iterator = {
        next: function() {
            var value = array.shift();
            return {
                done: value === void 0,
                value: value
            };
        }
    };
    if (hasIterable) {
        iterator[Symbol.iterator] = function() {
            return iterator;
        };
    }
    return iterator;
}
// src/_/es.map.ts
var MapCtor = /*#__PURE__*/ function() {
    function MapCtor(entries) {
        var _this = this;
        _class_call_check(this, MapCtor);
        __publicField(this, "size", 0);
        __publicField(this, "_entries", []);
        if (!isArray(entries) && entries) {
            throw new Error("".concat(_type_of(this._entries), " is not iterable (cannot read property Symbol(Symbol.iterator))"));
        }
        var _entries = toArray(entries);
        _entries.forEach(function(param) {
            var _param = _sliced_to_array(param, 2), key = _param[0], value = _param[1];
            return _this.set(key, value);
        });
    }
    _create_class(MapCtor, [
        {
            key: "clear",
            value: function clear() {
                this._entries = [];
                this.size = 0;
            }
        },
        {
            key: "delete",
            value: function _delete(key) {
                var index = findIndex(this._entries, function(param) {
                    var _param = _sliced_to_array(param, 1), k = _param[0];
                    return k === key;
                });
                if (index !== -1) {
                    this.size--;
                    this._entries.splice(index, 1);
                    return true;
                }
                return false;
            }
        },
        {
            key: "forEach",
            value: function forEach(cb) {
                var _this = this;
                if (typeof cb !== "function") throw new TypeError("".concat(cb, " is not a function"));
                this._entries.forEach(function(param) {
                    var _param = _sliced_to_array(param, 2), key = _param[0], value = _param[1];
                    cb && cb(value, key, _this);
                });
            }
        },
        {
            key: "get",
            value: function get(key) {
                var result = find(this._entries, function(param) {
                    var _param = _sliced_to_array(param, 1), k = _param[0];
                    return k === key;
                });
                if (result) {
                    var _result = _sliced_to_array(result, 2), key2 = _result[0], value = _result[1];
                    return value;
                }
            }
        },
        {
            key: "has",
            value: function has(key) {
                return findIndex(this._entries, function(param) {
                    var _param = _sliced_to_array(param, 1), k = _param[0];
                    return k === key;
                }) !== -1;
            }
        },
        {
            key: "entries",
            value: function entries() {
                var iterators = [];
                this.forEach(function(value, key) {
                    return iterators.push([
                        key,
                        value
                    ]);
                });
                return createIterator(iterators);
            }
        },
        {
            key: "keys",
            value: function keys() {
                var iterators = [];
                this.forEach(function(_value, key) {
                    return iterators.push(key);
                });
                return createIterator(iterators);
            }
        },
        {
            key: "values",
            value: function values() {
                var iterators = [];
                this.forEach(function(value) {
                    return iterators.push(value);
                });
                return createIterator(iterators);
            }
        },
        {
            key: "set",
            value: function set(key, value) {
                if (!this.has(key)) this.size++;
                this._entries.push([
                    key,
                    value
                ]);
                return this;
            }
        }
    ]);
    return MapCtor;
}();
if (hasIterable) {
    MapCtor.prototype[Symbol.iterator] = function entries() {
        return this.entries();
    };
    Object.defineProperty(MapCtor.prototype, Symbol.toStringTag, {
        value: "Map"
    });
    Object.defineProperty(MapCtor.prototype, Symbol.iterator, {
        configurable: false,
        writable: false,
        enumerable: false
    });
}
// src/_/polyfill.ts
if (typeof window !== "undefined") {
    if (typeof window.Promise === "undefined") {
        Object.defineProperty(window, "Promise", {
            value: PromisePolyfill__default.default
        });
    }
    if (typeof window.Map === "undefined") {
        Object.defineProperty(window, "Map", {
            value: MapCtor
        });
    }
}
// src/index.ts
var src_default = _object_spread({
    version: version,
    Compartment: Compartment
}, string_exports, array_exports, number_exports, browser_exports, matche_exports, convert_exports, object_exports, functional_exports, url_exports, date_exports, base64_exports);
Object.defineProperty(exports, "divide", {
    enumerable: true,
    get: function get() {
        return numberPrecision.divide;
    }
});
Object.defineProperty(exports, "minus", {
    enumerable: true,
    get: function get() {
        return numberPrecision.minus;
    }
});
Object.defineProperty(exports, "plus", {
    enumerable: true,
    get: function get() {
        return numberPrecision.plus;
    }
});
Object.defineProperty(exports, "times", {
    enumerable: true,
    get: function get() {
        return numberPrecision.times;
    }
});
exports.Compartment = Compartment;
exports.MapCtor = MapCtor;
exports.blobToDataURL = blobToDataURL;
exports.convert = convert;
exports.convertFlat = convertFlat;
exports.convertFlatPaths = convertFlatPaths;
exports.convertTree = convertTree;
exports.countDown = countDown;
exports.dataURLtoBlob = dataURLtoBlob;
exports.debounce = debounce;
exports.debounceEnd = debounceEnd;
exports.debounceStart = debounceStart;
exports.decode = decode2;
exports.deepClone = deepClone;
exports.default = src_default;
exports.downloadContent = downloadContent;
exports.dynamicImport = dynamicImport;
exports.encode = encode2;
exports.findPathByLeaf = findPathByLeaf;
exports.formatHMS = formatHMS;
exports.formatTime = formatTime;
exports.get = get;
exports.getImgToBase64 = getImgToBase64;
exports.getImgToBlob = getImgToBlob;
exports.getType = getType;
exports.getTypeTag = getTypeTag;
exports.guid = guid;
exports.hasIterable = hasIterable;
exports.hasOwn = hasOwn;
exports.isArray = isArray;
exports.isArrayLike = isArrayLike;
exports.isArraySafeLength = isArraySafeLength;
exports.isBigInt = isBigInt;
exports.isBoolean = isBoolean;
exports.isDate = isDate;
exports.isEmpty = isEmpty;
exports.isFunction = isFunction;
exports.isInteger = isInteger;
exports.isNaN = isNaN2;
exports.isNull = isNull;
exports.isNumber = isNumber;
exports.isObject = isObject;
exports.isPrimeObject = isPrimeObject;
exports.isPromise = isPromise;
exports.isRegExp = isRegExp;
exports.isString = isString;
exports.isSymbol = isSymbol;
exports.isUndefined = isUndefined;
exports.mask = mask;
exports.maskLeft = maskLeft;
exports.maskRight = maskRight;
exports.maxNumBy = maxNumBy;
exports.memoize = memoize;
exports.merge = merge;
exports.minNumBy = minNumBy;
exports.orderBy = orderBy;
exports.queryVar = queryVar;
exports.randomInteger = randomInteger;
exports.round = round;
exports.selector = selector;
exports.sensitive = sensitive;
exports.sensitiveLeft = sensitiveLeft;
exports.sensitiveRight = sensitiveRight;
exports.setClipboardData = setClipboardData;
exports.shuffle = shuffle;
exports.sleep = sleep;
exports.throttle = throttle;
exports.toArray = toArray;
exports.toArraySafeLength = toArraySafeLength;
exports.toFinite = toFinite;
exports.toInteger = toInteger;
exports.toNumber = toNumber;
exports.toString = toString;
exports.toThousands = toThousands;
exports.treeFlat = treeFlat;
exports.trim = trim;
exports.unique = unique;
exports.uniqueBy = uniqueBy;
exports.unix = unix;
exports.url = url;
exports.urlSearchParams = urlSearchParams;
exports.urlSearchStringify = urlSearchStringify;
exports.uuid = uuid;
exports.whileEach = whileEach;
